<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		jt_admin.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class JoaktreeControllerJt_admin extends JoaktreeController {
	function __construct() {
		//Get View
		if(JRequest::getCmd('view') == '') {
			JRequest::setVar('view', 'jt_admin');
		}
		
		parent::__construct();
		
		$this->registerTask( 'save', 'save' );
		
		// three tasks for publishing
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'publishAll', 'publishAll' );
		$this->registerTask( 'unpublishAll', 'unpublishAll' );
		// three tasks for living
		$this->registerTask( 'updateLiving', 'living' );
		$this->registerTask( 'livingAll', 'livingAll' );
		$this->registerTask( 'notLivingAll', 'notLivingAll' );
		// three tasks for page switch
		$this->registerTask( 'updatePage', 'page' );
		$this->registerTask( 'pageAll', 'pageAll' );
		$this->registerTask( 'noPageAll', 'noPageAll' );
		
		$this->registerTask( 'processGedCom', 'import' );
	}

	function save() {
		$model = $this->getModel('jt_admin');
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function publish() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->publish();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function publishAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->publishAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function unpublishAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->unpublishAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function living() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->living();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function livingAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->livingAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function notLivingAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->notLivingAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function page() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->page();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function pageAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->pageAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}

	function noPageAll() {
		$model = $this->getModel('jt_admin');
		
		$msg = $model->noPageAll();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}
	
	function import() {
		$model = $this->getModel('joaktree');
		
		$msg = $model->getGedcom();
		
		$link = 'index.php?option=com_joaktree&view=jt_admin';
		$this->setRedirect($link, $msg);
	}
}
?>