<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		jt_familytree
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class JoaktreeControllerJt_familytree extends JoaktreeController {
	function __construct() {
		//Get View
		if(JRequest::getCmd('view') == '') {
			JRequest::setVar('view', 'jt_familytree');
		}
		
		parent::__construct();
		
		$this->registerTask( 'assignFamilyTree', 'assignFamilyTree' );
		$this->registerTask( 'unpublish'       , 'publish' );
		$this->registerTask( 'add'             , 'edit' );
		$this->registerTask( 'remove'          , 'delete' );
	}

	function assignFamilyTree() {
		$model = $this->getModel('jt_familytree');
		
		$msg = $model->assignFamilyTree();
		
		$link = 'index.php?option=com_joaktree&view=jt_familytree';
		$this->setRedirect($link, $msg);
	}

	function publish() {
		$model = $this->getModel('jt_familytree');
		
		$msg = $model->publish();
		
		$link = 'index.php?option=com_joaktree&view=jt_familytree';
		$this->setRedirect($link, $msg);
	}

	function edit() {
		JRequest::setVar( 'view', 'jt_tree' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar( 'hidemainmenu', 1 );
		
		parent::display();
	}

	function delete() {
		$cids	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$model = $this->getModel('jt_tree');
		$msg   = 'Delete: ';
		
		foreach ($cids as $cid_num => $cid) {
			$id  = (int) $cid;
			$msg = $msg . $model->delete($id);
		}
		
		$link = 'index.php?option=com_joaktree&view=jt_familytree';
		$this->setRedirect($link, $msg);
	}
}
?>