<?php
/**
 * Joomla! 1.5 component JOaktree
 *
 * @version	1.0.1
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Initialize the database
$db =& JFactory::getDBO();
$update_queries = array ();
$application = JFactory::getApplication();

$version = 'v1.0';
 

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_admin_persons '
   .'( id               varchar(7)            NOT NULL '
   .', default_tree_id  int(11)      default  NULL '
   .', published        tinyint(1)            NOT NULL '
   .', living           tinyint(1)            NOT NULL '
   .', page             tinyint(1)            NOT NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_gedcom_objectlines '
   .'( id               int(11)      unsigned NOT NULL auto_increment '
   .', object_id        varchar(10)           NOT NULL '
   .', order_nr         int(11)               NOT NULL '
   .', level            int(11)               NOT NULL '
   .', tag              varchar(4)            NOT NULL '
   .', value            varchar(100) default  NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_gedcom_objects '
   .'( id               int(11)      unsigned NOT NULL auto_increment '
   .', tag              varchar(4)            NOT NULL '
   .', value            varchar(50)  default  NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_persons '
   .'( id               varchar(7)            NOT NULL '
   .', firstName        varchar(50)           NOT NULL '
   .', patronym         varchar(50)           NOT NULL '
   .', namePreposition  varchar(15)           NOT NULL '
   .', familyName       varchar(50)           NOT NULL '
   .', sex              char(1)               NOT NULL '
   .', birthDate        varchar(30)  default  NULL '
   .', birthPlace       varchar(50)  default  NULL '
   .', deathDate        varchar(30)  default  NULL '
   .', deathPlace       varchar(50)  default  NULL '
   .', burialDate       varchar(30)  default  NULL '
   .', burialPlace      varchar(50)  default  NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_person_sources '
   .'( id               varchar(15)           NOT NULL '
   .', person_id        varchar(7)            NOT NULL '
   .', source_id        varchar(7)            NOT NULL '
   .', sourceText       varchar(250)          NOT NULL '
   .', PRIMARY KEY  (id, sourceText) '
   .', KEY person_id (person_id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_relations '
   .'( id               varchar(15)           NOT NULL '
   .', person_id        varchar(7)   default  NULL '
   .', to_person_id     varchar(7)   default  NULL '
   .', type             enum( ' . $db->Quote( 'father' )
                          .', ' . $db->Quote( 'mother' )
			  .', ' . $db->Quote( 'husband' )
			  .', ' . $db->Quote( 'wife' )
			  .')                 NOT NULL '
   .', orderNr          smallint(2)  default  NULL '
   .', marriageDate     varchar(30)  default  NULL '
   .', marriagePlace    varchar(50)  default  NULL '
   .', rel_marriageDate varchar(30)  default  NULL '
   .', rel_marriagePlace varchar(50) default  NULL '
   .', PRIMARY KEY  (id) '
   .', KEY person_id (person_id) '
   .', KEY to_person_id (to_person_id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_repositories '
   .'( id               varchar(7)            NOT NULL '
   .', name             varchar(50)           NOT NULL '
   .', website          varchar(100) default  NULL '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_sources '
   .'( id               varchar(7)            NOT NULL '
   .', repo_id          varchar(7)   default  NULL '
   .', title            varchar(250) default  NULL '
   .', author           varchar(250) default  NULL '
   .', publication      varchar(250) default  NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_trees '
   .'( id               int(11)      unsigned NOT NULL auto_increment '
   .', root_person_id   varchar(7)            NOT NULL '
   .', published        tinyint(1)            NOT NULL default 1 '
   .', name             varchar(250)          NOT NULL '
   .', introText        mediumtext                NULL '
   .', PRIMARY KEY  (id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'CREATE TABLE IF NOT EXISTS '
   .'#__joaktree_tree_persons '
   .'( id               varchar(15)           NOT NULL '
   .', tree_id          int(11)               NOT NULL '
   .', person_id        varchar(7)            NOT NULL '
   .', type             enum( ' . $db->Quote( 'R' )
                          .', ' . $db->Quote( 'P' )
			  .', ' . $db->Quote( 'C' )
			  .')                 NOT NULL '
   .', lineage          varchar(100) default  NULL '
   .', PRIMARY KEY  (id) '
   .', KEY person_id (person_id) '
   .') '
   .'ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT="'.$version.'" ';

$update_queries[] = 
    'UPDATE #__components '
   .'SET admin_menu_img=\'..'.DS.'administrator'.DS.'components'.DS.'com_joaktree'.DS.'assets'.DS.'images'.DS.'icon-16-joaktree.png\' '
   .'WHERE admin_menu_link LIKE \'option=com_joaktree%\'';

$update_queries[] = 
    'UPDATE #__components '
   .'SET admin_menu_img=\'..'.DS.'administrator'.DS.'components'.DS.'com_joaktree'.DS.'assets'.DS.'images'.DS.'icon-16-person.png\' '
   .'WHERE admin_menu_link LIKE \'%view=jt_admin%\'';

$update_queries[] = 
    'UPDATE #__components '
   .'SET admin_menu_img=\'..'.DS.'administrator'.DS.'components'.DS.'com_joaktree'.DS.'assets'.DS.'images'.DS.'icon-16-familytree.png\' '
   .'WHERE admin_menu_link LIKE \'%view=jt_familytree%\'';

// Perform all queries - we don't care if it fails
foreach( $update_queries as $query ) {
    $db->setQuery( $query );
    $db->query();
}

$application->enqueueMessage( JText::_( 'Database tables are installed for version: ' ).$version, 'notice' ) ;
?>