<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		jt_tree model - jt_tree.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joaktree'.DS.'tables');
JModel::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joaktree'.DS.'models');


// Import Joomla! libraries
jimport('joomla.application.component.model');

class JoaktreeModelJt_tree extends JModel {

	var $_id;
	var $_data;

	function __construct() {
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);

	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function _buildQuery()
	{
		$query = 'SELECT jte.* '
			.'FROM   #__joaktree_trees jte ' 
			.'WHERE  jte.id = ' . $this->_id;

		return $query;
	}

	function getData() {
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
                     $query = $this->_buildQuery();
		     $this->_db->setQuery( $query );
                     $this->_data = $this->_db->loadObject();
		}
		
		return $this->_data;
	 }

	function store($data) {
		// initialize tables and records
		$row   = & JTable::getInstance('joaktree_trees', 'Table');
					
		// Bind the form fields to the table
		$row->id             = $data['id'];
		$row->root_person_id = $data['root_person_id'];
		$row->name           = $data['name'];
		$row->introText      = $data['content'];
		
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Make sure the table is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return 'Tree stored (' . $row->_tbl_key .' = ' . $row->id . ')';
	}
	
	function delete($id) {
		// initialize tables and records
		$row   = & JTable::getInstance('joaktree_trees', 'Table');
					
		// Store the table to the database
		if (!$row->delete($id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return $row->_tbl_key . '=' . $id . ';';
	}
}
?>