<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		table: joaktree_relations.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 */

 defined('_JEXEC') or die('Restricted access');
jimport('joomla.filter.input');

class TableJoaktree_relations extends JTable
{
	var $id			= null;
	var $person_id		= null;
	var $to_person_id	= null;
	var $type		= null;
	var $orderNr		= null;
	var $marriageDate	= null;
	var $marriagePlace	= null;
	var $rel_marriageDate	= null;
	var $rel_marriagePlace	= null;

	function __construct(& $db) {
		parent::__construct('#__joaktree_relations', 'id', &$db);
	}

	function loadEmpty() {
		$this->id		 = null;
		$this->person_id	 = null;
		$this->to_person_id	 = null;
		$this->type		 = null;
		$this->orderNr		 = null;
		$this->marriageDate	 = null;
		$this->marriagePlace	 = null;
		$this->rel_marriageDate	 = null;
		$this->rel_marriagePlace = null;
	}

	function deleteRelations($person_id) {
		if ($person_id == null) {
			// no person given -> nothing to do
			return false;
		} else {
			// delete records are found for this person
			$query = 'DELETE FROM ' . $this->_tbl . ' '
				.'WHERE person_id = ' . $this->_db->Quote( $person_id );
			$this->_db->setQuery( $query );
			$result = $this->_db->query();       
               }
	       
	       if ($result) {
		       // everything went fine
		       return true;
	       } else {
		       // something went wrong -> error messages is returned.
		       return $this->setError($this->_db->getErrorMsg());
	       }
	}

	function store() {
		$query = 'SELECT 1 '
	       		.'FROM             ' . $this->_tbl . ' '
			.'WHERE id       = ' . $this->_db->Quote( $this->id );
		
		// execute query and retrieve result
		$this->_db->setQuery( $query );
		$result = $this->_db->loadResult();
		
		// if query has no result, record does not exists yet and is added here
		// if query has result, record exists yet and is updated here
		if (!$result) {
			$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
		} else {
			$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key );
		}
		
		return $ret;
       }
}
?>