<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		administrator jt_admin view - view.html.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.application.component.view');

class JoaktreeViewJt_admin extends JView {
	function display($tpl = null) {
		
		global $mainframe, $option;
		
		JHTML::stylesheet( 'joaktree_admin.css', 'administrator/components/com_joaktree/assets/css/' );
		
		JToolBarHelper::title(   '&nbsp;&nbsp;' .JText::_( 'Joaktree Persons' ), 'person' );
		JToolBarHelper::custom( 'publishAll', 'publish', 'publish', 'publish all', false, false );
		JToolBarHelper::custom( 'unpublishAll', 'unpublish', 'unpublish', 'unpublish all', false, false );
		JToolBarHelper::custom( 'livingAll', 'living', 'living', 'living all', false, false );
		JToolBarHelper::custom( 'notLivingAll', 'notliving', 'notliving', 'not living all', false, false );
		JToolBarHelper::custom( 'pageAll', 'page', 'page', 'page all', false, false );
		JToolBarHelper::custom( 'noPageAll', 'nopage', 'nopage', 'no page all', false, false );
		JToolBarHelper::custom( 'processGedCom', 'gedcom', 'gedcom', 'process GedCom', false, false );
		JToolBarHelper::preferences('com_joaktree', '460');
		JToolBarHelper::help('screen.chapter05', true);
		
		// Get parameters
		$params           	= JComponentHelper::getParams('com_joaktree') ;
		$patronymSetting	= (int) $params->get('patronym');
		$lists['patronym'] 	= $patronymSetting;
 		
		// Get data from the model
		$items	     = & $this->get( 'Persons' );
		$trees	     = & $this->get( 'Trees' );
		$pagination  = & $this->get( 'Pagination' );
		$gedcom      = & $this->get( 'Gedcom' );
		
		//Filter
		$context			= 'com_joaktree.jt_admin.list.';
		
		$filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',		'filter_state',		'',		'word' );
		$filter_living		= $mainframe->getUserStateFromRequest( $context.'filter_living',	'filter_living',	'',		'word' );
		$filter_page		= $mainframe->getUserStateFromRequest( $context.'filter_page',		'filter_page',		'',		'word' );
		$filter_tree		= $mainframe->getUserStateFromRequest( $context.'filter_tree',		'filter_tree',		'',		'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'jpn.id',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',		'word' );
		$search1		= $mainframe->getUserStateFromRequest( $context.'search1',		'search1',		'',		'string' );
		$search1		= JString::strtolower( $search1 );
		$search2		= $mainframe->getUserStateFromRequest( $context.'search2',		'search2',		'',		'string' );
		$search2		= JString::strtolower( $search2 );
		$search3		= $mainframe->getUserStateFromRequest( $context.'search3',		'search3',		'',		'string' );
		$search3		= JString::strtolower( $search3 );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search1']= $search1;
		$lists['search2']= $search2;
		$lists['search3']= $search3;

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		$select_attr = array();
		$select_attr['class'] = 'inputbox';
		$select_attr['size'] = '1';
		$select_attr['onchange'] = 'submitform( );';
		$value = 'value';
		$text = 'text';

		// living filter
		$living = array();
		$living[0][$value] = 'S';
		$living[0][$text]  = '-Select living-';       
		$living[1][$value] = 'L';
		$living[1][$text]  = 'living';
		$living[2][$value] = 'D';
		$living[2][$text]  = 'not living';
      
		$lists['living']	= JHTMLSelect::genericlist($living, 'filter_living', $select_attr, $value, $text, $filter_living );
	   
		// page filter
		$page = array();
		$pag_attr = array();
		$page[0][$value] = 'S';
		$page[0][$text]  = '-Select page-';       
		$page[1][$value] = 'Y';
		$page[1][$text]  = 'page';
		$page[2][$value] = 'N';
		$page[2][$text]  = 'no page';
		
		$lists['page']	= JHTMLSelect::genericlist($page, 'filter_page', $select_attr, $value, $text, $filter_page );
		
		// default family tree filter
		$tree = array();
		$tree_attr = array();
		$tree[0][$value] = 0;
		$tree[0][$text]  = '-Select tree-'; 
		
		for ($i = 1; $i <= count($trees); $i++) {
			$tree[$i][$value] = $trees[$i-1]->id;
			$tree[$i][$text]  = $trees[$i-1]->name;
		}
		
		$lists['tree']	= JHTMLSelect::genericlist($tree, 'filter_tree', $select_attr, $value, $text, $filter_tree );
		
		$this->assignRef( 'gedcom'    ,  $gedcom );
		$this->assignRef( 'items'     ,  $items );
		$this->assignRef( 'pagination',	$pagination);
		$this->assignRef( 'lists'     ,	$lists);
		
		parent::display($tpl);
	}
}
?>