<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		administrator jt_familytree view - view.html.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.application.component.view');

class JoaktreeViewJt_familytree extends JView {
	function display($tpl = null) {
	
		global $mainframe, $option;
		
		JHTML::stylesheet( 'joaktree_admin.css', 'administrator/components/com_joaktree/assets/css/' );
		
		JToolBarHelper::title(   '&nbsp;&nbsp;' .JText::_( 'Joaktree Family trees' ), 'familytree' );
		JToolBarHelper::addNew();
		JToolBarHelper::editList();
		JToolBarHelper::deleteList();
		JToolBarHelper::custom( 'assignFamilyTree', 'assignfamilytree', 'assignfamilytree', 'assign family tree', false, false );
		JToolBarHelper::preferences('com_joaktree', '460');
		JToolBarHelper::help('screen.chapter04.html', true);
		
		// Get data from the model
		$items			= & $this->get( 'Data' );
		$pagination		= & $this->get( 'Pagination' );
		
		//Filter
		$context		= 'com_joaktree.jt_familytree.list.';
		
		$filter_state		= $mainframe->getUserStateFromRequest( $context.'filter_state',		'filter_state',		'',	'word' );
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'jte.id',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',	'word' );
		$search			= $mainframe->getUserStateFromRequest( $context.'search',			'search',	'',	'string' );
		$search			= JString::strtolower( $search );
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		// search filter
		$lists['search']= $search;
		
		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );
		
		$this->assignRef( 'items',  $items );
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('lists',		$lists);
		
		parent::display($tpl);
	}
}
?>