///////////////////////////////////////////////////////////////// 
// the DOLLAR-jt function for creating an object out of ID or Object
function $jt() {
	var elements = new Array();
	for (var i = 0; i < arguments.length; i++) {
		var element = arguments[i];
		if (typeof element == 'string')
			element = document.getElementById(element);
		if (arguments.length == 1)
			return element;
		elements.push(element);
	}
	return elements;
}

////////////////////////
//	This function checks if a class is in a specified element
//
function isClassInElement(oElement, sClassName) {
	if(oElement == null) return false;
    if(sClassName=="*") return true;
	return new RegExp('\\b'+sClassName+'\\b').test(oElement.className)
}

////////////////////////
// adds a class on an element
//
function addClassToElement(oElement, sClassName) {
	if (!isClassInElement(oElement, sClassName)) {
		oElement.className += oElement.className ? (' ' + sClassName) : sClassName;
	}
}

////////////////////////
// removes a class from an element
//
function removeClassFromElement(oElement, sClassName) {
	if( isClassInElement(oElement, sClassName)){
		var oPattern = oElement.className.match(' '+sClassName) ? (' ' + sClassName) : sClassName;
		oElement.className = oElement.className.replace(oPattern,'');
	}
}

////////////////////////
// swap two classes on an element
//
function swapClassInElement(oElement,sClassName,sClassName2){
	if(oElement != null){
		if( isClassInElement(oElement, sClassName)){
			removeClassFromElement(oElement, sClassName);
			addClassToElement(oElement, sClassName2);
		}
		else{
			removeClassFromElement(oElement, sClassName2);
			addClassToElement(oElement, sClassName);
		}
	}
}

////////////////////////
// toggle visibility of an array of elements depending on a classname or style
//
function toggle() {
	var oEl, i;
	for (i=0; i < arguments.length; i++ ) {
		if($jt(arguments[i])){
			oEl = $jt(arguments[i]);
			if(isClassInElement(oEl, 'jt-sources-open') | isClassInElement(oEl, 'jt-sources-closed')) 
                          swapClassInElement(oEl,'jt-sources-open','jt-sources-closed');
			if(isClassInElement(oEl, 'jt-hide') | isClassInElement(oEl, 'jt-show')) 
				swapClassInElement(oEl,'jt-hide','jt-show');
			// else oEl.style.display =  (oEl.style.display != 'none' ) ? 'none' : '' ;
		}
	}
	return false;
}
