<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		front end joaktree model - joaktree.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

JModel::addIncludePath(JPATH_COMPONENT.DS.'models');

class JoaktreeModelJoaktree extends JModel {
	function __construct() {
		parent::__construct();            
		 
		$this->id = array();
		$this->id[ 'person_id' ] = JRequest::getVar('personId'); 
		$this->id[ 'tree_id' ]     = JRequest::getVar('treeId'); 

		if (!$this->id[ 'person_id' ]) {
			$query = 'SELECT root_person_id FROM #__joaktree_trees WHERE id = ' . $this->id[ 'tree_id' ] ;
			$this->_db->setQuery( $query );
			$this->id[ 'person_id' ]= $this->_db->loadResult();               
		}

		$model = & JModel::getInstance('joaktreeperson', '', $this->id);
	} 

	function getPerson() {
		$person = new joaktreeperson($this->id);
		
		return $person;
	}

	function getPictures() {
		global $mainframe;
		$params	= &$mainframe->getParams();
		$sequence  = $params->get('Sequence', 0);
		
		// sequence == 0: Disable pictures
		if ( $sequence != 0 ) {
			$picArray = array();
			$directoryBase = $params->get('Directory', 'images/joaktree');
			
			if (is_dir($directoryBase.DS.$this->id[ 'person_id' ]) ) {
				$directory = $directoryBase.DS.$this->id[ 'person_id' ];
			} else {
				$query = 'SELECT name FROM #__joaktree_trees WHERE id = ' . $this->id[ 'tree_id' ] ;
				$this->_db->setQuery( $query );
				$directory = $this->_db->loadResult();               
				$directory = $directoryBase.DS.$directory;
				
				if (!is_dir( $directory )) {
					// if no directories are found, take the default directory with pictures
					$directory = 'images/joaktree/jt-images';
				}
			}
			
			if (is_dir( $directory )) {
				if ($dh = opendir( $directory )) {
					while ($file = readdir($dh)) {
						$uprFile = strtoupper($file);
						if ($uprFile != '.' && $uprFile != '..') {
							if (strpos($uprFile, '.GIF',1)||strpos($uprFile, '.JPG',1)||strpos($uprFile, '.PNG',1) ||strpos($uprFile, '.BMP',1)) {
								array_push($picArray,  $directory.DS.$file);
							}
						}
					}
					closedir($dh);
				}
			}
			
			switch ( $sequence ) {
				case 1: // Natural sort
					natsort($picArray);
					break;
				case 2:	// Shuffle at beginning
				case 3: // Shuffle at beginning (take later the first element only)
				case 4: // Shuffle at beginning (take later the first element only)
					shuffle($picArray);
					break;
			}
		}
		
		return $picArray;
	}
}
?>