<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		front end joaktreelist model - joaktreelist.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class JoaktreeModelJoaktreelist extends JModel {

	var $_personlist;
	var $_pagination	= null;
	var $_total		= null;
	var $_tree_id		= null;
	var $_list_menu_id	= null;
	var $_person_menu_id	= null;
	var $_patronymSetting;
	var $filter3		= null;

	function __construct() {
		parent::__construct();

		$this->params           = JComponentHelper::getParams('com_joaktree') ;
		$this->_patronymSetting	= (int) $this->params->get('patronym');
		
		global $mainframe, $option;		
		$context			= 'com_joaktree.joaktreelist.list.';
		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );

		$limitstart	= $mainframe->getUserStateFromRequest( $context.'limitstart',	'limitstart',	0, 'int' );
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
                $this->_tree_id = JRequest::getVar('treeId'); 

		$query = 'SELECT id '
			.'FROM #__menu '
			.'WHERE link like ' . $this->_db->Quote( '%view=joaktreelist%' ) . ' '
			.'AND link like ' . $this->_db->Quote( '%treeId='.$this->_tree_id.'%' ) . ' ';

		$this->_db->setQuery( $query );
		$this->_list_menu_id = $this->_db->loadResult();

		$query = 'SELECT id '
			.'FROM #__menu '
			.'WHERE link like ' . $this->_db->Quote( '%&view=joaktree&%' ) . ' '
			.'AND link like ' . $this->_db->Quote( '%treeId='.$this->_tree_id.'%' ) . ' ';

		$this->_db->setQuery( $query );
		$this->_person_menu_id = $this->_db->loadResult();
		
		//$this->filter3 	= JRequest::getVar( 'familyName' );
	}

	function _buildQuery()
	{
		// Get the WHERE and ORDER BY clauses for the query
		$where      =  $this->_buildContentWhere();
		$orderby    =  $this->_buildContentOrderBy();

		$query = 'SELECT  jpn.id '
                        .',       jpn.firstName '
                        .',       jpn.patronym '
			.',       IF( jpn.namePreposition = '.$this->_db->Quote('').' '
			.'          , jpn.familyName '
			.'          , CONCAT_WS('.$this->_db->Quote(', ').',jpn.familyName,jpn.namePreposition) '
			.'          ) AS familyName '
                        .',       if (jan.living = 0, SUBSTR(jpn.birthDate, -4), NULL) AS birthDate '
                        .',       if (jan.living = 0, SUBSTR(jpn.deathDate, -4), NULL) AS deathDate '
                        .'FROM    (    #__joaktree_persons jpn '
			.'        JOIN #__joaktree_admin_persons jan '
			.'        ON   ( jan.id = jpn.id ) '
			.'        ) '
			.'JOIN    #__joaktree_tree_persons jtp '
			.'ON      ( jpn.id = jtp.person_id ) '
                        . $where
                        . $orderby;

		return $query;
	}

	function _buildContentWhere()
	{
		global $mainframe;

		$context			= 'com_joaktree.joaktreelist.list.';
		$search1			= $mainframe->getUserStateFromRequest( $context.'search1',	'search1',	'',	'string' );
		$search1			= JString::strtolower( $search1 );
		$search2			= $mainframe->getUserStateFromRequest( $context.'search2',	'search2',	'',	'string' );
		$search2			= JString::strtolower( $search2 );
		$search3			= $mainframe->getUserStateFromRequest( $context.'search3',	'search3',	'',	'string' );
		$search3			= JString::strtolower( $search3 );

		$where = array();

		$where[] = 'jan.published = 1 '; 
                $where[] = 'jan.page = true '; 

                if ($this->_tree_id) {
                       $where[] = 'jtp.tree_id = ' . $this->_tree_id;
                }

		if ($search1) {
			$where[] = 'LOWER(jpn.firstName) LIKE '.$this->_db->Quote('%'.$search1.'%');
		}

		if ($search2) {
			$where[] = 'LOWER(jpn.patronym) LIKE '.$this->_db->Quote('%'.$search2.'%');
		}

		if ($search3) {
			$where[] = 'LOWER(jpn.familyName) LIKE '.$this->_db->Quote('%'.$search3.'%') ;
		}

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function _buildContentOrderBy()
	{
		global $mainframe;

		$context		= 'com_joaktree.joaktreelist.list.';
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'jpn.familyName',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

		if ($filter_order == 'jpn.familyName'){
			$orderby 	= ' ORDER BY  jpn.familyName '.$filter_order_Dir.', jpn.firstName '.$filter_order_Dir.' ';
		} else {
                        $orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.', jpn.familyName '.$filter_order_Dir.' ';
		}

		return $orderby;
	}

	function getPersonlist() {
		// Lets load the content if it doesn't already exist
		if (empty($this->_personlist)) {
			$query = $this->_buildQuery();
			$this->_personlist = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
		}
		
		return $this->_personlist;
	}

	function getTree_id() {        
		return $this->_tree_id;
	}

	function getList_menu_id() {        
		return $this->_list_menu_id;
	}

	function getPerson_menu_id() {        
		return $this->_person_menu_id;
	}

	function getPatronymSetting() {        
		return $this->_patronymSetting;
	}

	function getFilter3() {
		return $this->filter3;
	}

	function publish() {
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$cids = implode( ',', $cid );

		$query = "UPDATE #__joaktree_admin_persons SET published = !published WHERE id = '$cid[0]'  ";
		$msg = $this->_getListCount( $query );
		
		return 'functie publish in joaktreelist' . $msg .'; id = ' . $cid[0] . ': query = ' . $query;
	}

	function living() {
		$cid = JRequest::getVar( 'cid' );
		$query = "UPDATE #__joaktree_admin_persons SET living = !living WHERE id = '$cid[0]'  ";
		$msg = $this->_getListCount( $query );
        
		return 'functie living in joaktreelist' . $msg .'; id = ' . $cid[0]. ': query = ' . $query;
	}

	function page() {
		$cid = JRequest::getVar( 'cid' );
		$query = "UPDATE #__joaktree_admin_persons SET page = !page WHERE id = '$cid[0]'  ";
		$msg = $this->_getListCount( $query );
		
		return 'functie page in joaktreelist' . $msg .'; id = ' . $cid[0]. ': query = ' . $query;
	}

	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		
		return $this->_total;
	}

	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		
		return $this->_pagination;
	}
}
?>