<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		front end joaktreeperson model - joaktreeperson.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.base.tree' );


JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joaktree'.DS.'tables');


class Joaktreeperson extends JObject { 

	// member declaration
	public $id;
	public $tree_id;
	public $menu_id;
	public $secondParent_id;
	public $orderNr;
	public $sex;
	public $firstName;
	public $patronym;
	public $firstNamePatronym;
	public $familyName;
	public $birthDate;
	public $birthPlace;
	public $deathDate;
	public $deathPlace;
	public $burialDate;
	public $burialPlace;
	public $marriageDate;
	public $marriagePlace;
	public $rel_marriageDate;
	public $rel_marriagePlace;
	public $living;
	public $page;
	public $lineage;
	public $patronymSetting;
	
	function __construct($id) {
		
		$this->_db 		= & JFactory::getDBO();        
		$this->params           = JComponentHelper::getParams('com_joaktree') ;
		$this->lineageSetting  	= (int) $this->params->get('lineage');
		$this->patronymSetting	= (int) $this->params->get('patronym');
		$this->patronymString	= $this->params->get('patronymSeparation');
		
		$query = 'SELECT  jtp.tree_id           AS tree_id '
			.',       jpn.id                AS id '
			.',       jan.default_tree_id   AS default_tree_id '
			.',       jpn.firstName         AS firstName '
			.',       jpn.patronym          AS patronym '
			.',       CONCAT_WS('.$this->_db->Quote(' ').',jpn.namePreposition,jpn.familyName) AS familyName '
			.',       jpn.sex               AS sex '
			.',       if ( jan.living = 0, jpn.birthDate, NULL )   AS birthDate '
			.',       if ( jan.living = 0, jpn.birthPlace, NULL )  AS birthPlace '
			.',       if ( jan.living = 0, jpn.deathDate, NULL )   AS deathDate '
			.',       if ( jan.living = 0, jpn.deathPlace, NULL )  AS deathPlace '
			.',       if ( jan.living = 0, jpn.burialDate, NULL )  AS burialDate '
			.',       if ( jan.living = 0, jpn.burialPlace, NULL ) AS burialPlace '
			.',       jan.living            AS living '
			.',       if( isnull( jan.default_tree_id ), 0, jan.page )  AS page '
			.',       jtp.lineage '
			.'FROM    (     #__joaktree_persons       jpn '
			.'        JOIN  #__joaktree_admin_persons jan '
			.'        ON    ( jan.id = jpn.id ) '
			.'        ) '
			.'LEFT JOIN  #__joaktree_tree_persons  jtp ' 
			.'ON         ( jtp.person_id = jpn.id ) '
			.'WHERE   jan.published = 1 '
			.'AND     jtp.tree_id    = ' . $id[ 'tree_id' ] . ' '
			.'AND     jpn.id = ' . $this->_db->Quote($id[ 'person_id' ]) . ' '
			.'UNION '
			.'SELECT  IFNULL( jtp.tree_id, IFNULL( jan.default_tree_id, ' . $id[ 'tree_id' ] . ') ) AS tree_id '
			.',       jpn.id                AS id '
			.',       jan.default_tree_id   AS default_tree_id '
			.',       jpn.firstName         AS firstName '
			.',       jpn.patronym          AS patronym '
			.',       CONCAT_WS('.$this->_db->Quote(' ').',jpn.namePreposition,jpn.familyName) AS familyName '
			.',       jpn.sex               AS sex '
			.',       if ( jan.living = 0, jpn.birthDate, NULL )   AS birthDate '
			.',       if ( jan.living = 0, jpn.birthPlace, NULL )  AS birthPlace '
			.',       if ( jan.living = 0, jpn.deathDate, NULL )   AS deathDate '
			.',       if ( jan.living = 0, jpn.deathPlace, NULL )  AS deathPlace '
			.',       if ( jan.living = 0, jpn.burialDate, NULL )  AS burialDate '
			.',       if ( jan.living = 0, jpn.burialPlace, NULL ) AS burialPlace '
			.',       jan.living            AS living '
			.',       if( isnull( jan.default_tree_id ), 0, jan.page )  AS page '
			.',       jtp.lineage '
			.'FROM    (     #__joaktree_persons       jpn '
			.'        JOIN  #__joaktree_admin_persons jan '
			.'        ON    ( jan.id = jpn.id ) '
			.'        ) '
			.'LEFT JOIN  #__joaktree_tree_persons  jtp ' 
			.'ON         ( jtp.person_id = jpn.id ) '
			.'WHERE   jan.published = 1 '
			.'AND     NOT EXISTS '
			.'           ( SELECT 1 '
			.'             FROM   #__joaktree_tree_persons  jtp2 '
			.'             WHERE  jtp2.person_id = jpn.id '
			.'             AND    jtp2.tree_id   = ' . $id[ 'tree_id' ] . ' '
			.'           ) '
			.'AND     jpn.id = ' . $this->_db->Quote($id[ 'person_id' ]) . ' ';
			
		$this->_db->setQuery( $query );
		
		$person  = $this->_db->loadAssoc();
		
		$this->id			= $person[ 'id' ];
		$this->tree_id			= $person[ 'tree_id' ];
		$this->secondParent_id		= null;
		$this->orderNr			= null;
		$this->sex			= $person[ 'sex' ];
		
		// when patronyms are shown, there are concatenated to the first name
		$this->firstName		= $person[ 'firstName' ];
		
		if ($person[ 'patronym' ] != null) {
			$this->patronym			= $this->patronymString.$person[ 'patronym' ].$this->patronymString;
		} else {
			$this->patronym			= null;
		}
		
		if (($this->patronymSetting == 0) or ($this->patronym == null)) {
			$this->firstNamePatronym	= $this->firstName;
		} else {
			$this->firstNamePatronym	= $this->firstName.' '.$this->patronym;
		}

		$this->familyName		= $person[ 'familyName' ];
		$this->birthDate		= $this->displayDate ( $person[ 'birthDate' ] );
		$this->birthPlace		= $person[ 'birthPlace' ];
		$this->deathDate		= $this->displayDate ( $person[ 'deathDate' ] );
		$this->deathPlace		= $person[ 'deathPlace' ];
		$this->burialDate		= $this->displayDate ( $person[ 'burialDate' ] );
		$this->burialPlace		= $person[ 'burialPlace' ];
		$this->marriageDate		= null;
		$this->marriagePlace		= null;
		$this->rel_marriageDate		= null;
		$this->rel_marriagePlace	= null;
		$this->living			= $person[ 'living' ];
		$this->page			= $person[ 'page' ];
		$this->lineage			= ltrim(rtrim($person[ 'lineage' ]));
		
		$query = 'SELECT id '
			.'FROM #__menu '
			.'WHERE link like ' . $this->_db->Quote( '%&view=joaktree&%' ) . ' '
			.'AND link like ' . $this->_db->Quote( '%&treeId='.$this->tree_id.'%' ) . ' ';
			
		$this->_db->setQuery( $query );
		$this->menu_id = $this->_db->loadResult();
	}

	function __destruct() {
		// print "Destroying " . $this->firstName . " " . $this->familyName . "\n";
	}

	private function displayDate( $dateString) {
		$result = str_replace ('ABT', JText::_('about'), $dateString ); 
		$result = str_replace ('BET', JText::_('between'), $result ); 
		$result = str_replace ('AND', JText::_('and'), $result ); 
		$result = str_replace ('JAN', JText::_('jan'), $result ); 
		$result = str_replace ('FEB', JText::_('feb'), $result ); 
		$result = str_replace ('MAR', JText::_('mar'), $result ); 
		$result = str_replace ('APR', JText::_('apr'), $result ); 
		$result = str_replace ('MAY', JText::_('may'), $result ); 
		$result = str_replace ('JUN', JText::_('jun'), $result ); 
		$result = str_replace ('JUL', JText::_('jul'), $result ); 
		$result = str_replace ('AUG', JText::_('aug'), $result ); 
		$result = str_replace ('SEP', JText::_('sep'), $result ); 
		$result = str_replace ('OCT', JText::_('oct'), $result ); 
		$result = str_replace ('NOV', JText::_('nov'), $result ); 
		$result = str_replace ('DEC', JText::_('dec'), $result ); 
		
		return $result;
	}

	public function getFathers() {
		$query = 'SELECT  jrn.to_person_id AS pid '
			.',       jrn.orderNr      AS orderNr '
			.',       0                AS marriageDate '
			.',       0                AS marriagePlace '
			.',       0                AS rel_marriageDate '
			.',       0                AS rel_marriagePlace '
			.',       0                AS secondParent_id '
			.'FROM    (    #__joaktree_relations jrn '
			.'        JOIN #__joaktree_admin_persons jan1 '
			.'        ON (   jan1.id = jrn.person_id '
			.'           AND jan1.published = 1 '
			.'           ) '
			.'        ) '
			.'JOIN    #__joaktree_admin_persons jan2 '
			.'ON      (   jan2.id = jrn.to_person_id '
			.'        AND jan2.published = 1 '
			.'        ) '
			.'WHERE   jrn.person_id= ' . $this->_db->Quote( $this->id ) . ' ' 
			.'AND     jrn.type = ' . $this->_db->Quote( 'father' ) . ' ' 
			.'ORDER BY jrn.orderNr ';
			
		$fathers = $this->getRelations($query);
		return $fathers;
	}

	public function getMothers() {
		$query = 'SELECT  jrn.to_person_id AS pid '
			.',       jrn.orderNr      AS orderNr '
			.',       0                AS marriageDate '
			.',       0                AS marriagePlace '
			.',       0                AS rel_marriageDate '
			.',       0                AS rel_marriagePlace '
			.',       0                AS secondParent_id '
			.'FROM    (    #__joaktree_relations jrn '
			.'        JOIN #__joaktree_admin_persons jan1 '
			.'        ON (   jan1.id = jrn.person_id '
			.'           AND jan1.published = 1 '
			.'           ) '
			.'        ) '
			.'JOIN    #__joaktree_admin_persons jan2 '
			.'ON      (   jan2.id = jrn.to_person_id '
			.'        AND jan2.published = 1 '
			.'        ) '
			.'WHERE   jrn.person_id= ' . $this->_db->Quote( $this->id ) . ' ' 
			.'AND     jrn.type = ' . $this->_db->Quote( 'mother' ) . ' ' 
			.'ORDER BY jrn.orderNr ';
			
		$mothers = $this->getRelations($query);
		return $mothers;
	}

	public function getPartners() {
		$query = 'SELECT  jrn.to_person_id AS pid '
			.',       jrn.orderNr      AS orderNr '
			.',       if ( (jan1.living = 0 AND jan2.living = 0 ), jrn.marriageDate, NULL ) AS marriageDate '
			.',       if ( (jan1.living = 0 AND jan2.living = 0 ), jrn.marriagePlace, NULL ) AS marriagePlace '
			.',       if ( (jan1.living = 0 AND jan2.living = 0 ), jrn.rel_marriageDate, NULL ) AS rel_marriageDate '
			.',       if ( (jan1.living = 0 AND jan2.living = 0 ), jrn.rel_marriagePlace, NULL ) AS rel_marriagePlace '
			.',       0                AS secondParent_id '
			.'FROM    (    #__joaktree_relations jrn '
			.'        JOIN #__joaktree_admin_persons jan1 '
			.'        ON (   jan1.id = jrn.person_id '
			.'           AND jan1.published = 1 '
			.'           ) '
			.'        ) '
			.'JOIN    #__joaktree_admin_persons jan2 '
			.'ON      (   jan2.id = jrn.to_person_id '
			.'        AND jan2.published = 1 '
			.'        ) '
			.'WHERE   jrn.person_id= ' . $this->_db->Quote( $this->id ) . ' ' 
			.'AND     jrn.type IN ('.$this->_db->Quote( 'wife' ).','.$this->_db->Quote( 'husband' ).') '
			.'ORDER BY jrn.orderNr ';
			
		$partners = $this->getRelations($query);
		return $partners;
	}

	public function getChildren() {
		$query = 'SELECT  jrn.person_id      AS pid '
			.',       jrn.orderNr        AS orderNr '
			.',       0                  AS marriageDate '
			.',       0                  AS marriagePlace '
			.',       0                  AS rel_marriageDate '
			.',       0                  AS rel_marriagePlace '
			.',       jrn2.to_person_id  AS secondParent_id '
			.'FROM    ( (    #__joaktree_relations jrn '
			.'          JOIN #__joaktree_admin_persons jan1 '
			.'          ON (   jan1.id = jrn.person_id '
			.'             AND jan1.published = 1 '
			.'             ) '
			.'          ) '
			.'        JOIN    #__joaktree_admin_persons jan2 '
			.'        ON      (   jan2.id = jrn.to_person_id '
			.'                AND jan2.published = 1 '
			.'                ) '
			.'        ) '
			.'LEFT JOIN #__joaktree_relations  jrn2 '
			.'ON        (   jrn2.person_id = jrn.person_id '
			.'          AND jrn2.to_person_id <> ' . $this->_db->Quote( $this->id ) . ' '
			.'          AND jrn2.type IN ('.$this->_db->Quote( 'father' ).','.$this->_db->Quote( 'mother' ).') '
			.'          )'
			.'WHERE   jrn.to_person_id = ' . $this->_db->Quote( $this->id ) . ' ' 
			.'AND     jrn.type IN ('.$this->_db->Quote( 'father' ).','.$this->_db->Quote( 'mother' ).') '
			.'ORDER BY jrn.orderNr ';
			
		$children = $this->getRelations($query);
		return $children;
	}

	private function getRelations($query) {
		$this->_db->setQuery( $query );
		
		$relations_id  = $this->_db->loadAssocList();
		
		foreach ($relations_id as $i => $relation_id) {
			$id[ 'person_id' ] = $relation_id['pid'];
			$id[ 'tree_id' ] = $this->tree_id ;
			$relations[ $i ] = new joaktreeperson($id);
			$relations[ $i ]->orderNr  = $relation_id['orderNr'];
			$relations[ $i ]->marriageDate  = $this->displayDate( $relation_id['marriageDate'] );
			$relations[ $i ]->marriagePlace  = $relation_id['marriagePlace'];
			$relations[ $i ]->rel_marriageDate  = $this->displayDate( $relation_id['rel_marriageDate'] );
			$relations[ $i ]->rel_marriagePlace  = $relation_id['rel_marriagePlace'];
			$relations[ $i ]->secondParent_id  = $relation_id['secondParent_id'];
		}
		return $relations;
	}

	public function getSources() {
		$query =   'SELECT jps.sourceText '
			.',          jse.title '
			.',          jse.author '
                        .',          jse.publication '
                        .',          jry.name AS repository'
                        .',          jry.website '
                        .'FROM #__joaktree_person_sources  jps '
                        .'LEFT JOIN #__joaktree_sources       jse '
                        .'ON ( jse.id = jps.source_id ) '
                        .'Left JOIN #__joaktree_repositories   jry '
                        .'ON ( jry.id = jse.repo_id ) '
                        .'WHERE jps.person_id= ' . $this->_db->Quote ( $this->id ) . ' '
                        .'ORDER BY jps.source_id ';
			
		$this->_db->setQuery( $query );
		$sources = $this->_db->loadObjectList();
		
		return $sources;
	}

     	public function getLineage() {
		// initialize 
		$ancestor = array();
		$lineageArray = array( $ancestor );
		$i = 0;
		$reference_fam_name = '';
		
		if ($this->lineageSetting != 0) {
			$elements  = explode(" ", $this->lineage);
			
			foreach ($elements as $element_num => $lineage_id) {
				if ($lineage_id != null) {
					$id[ 'person_id' ] = $lineage_id;
					$id[ 'tree_id' ] = $this->tree_id ;
					$tmp = new joaktreeperson($id);
					
					$lineageArray[ $i ][ 'person_id' ] = $lineage_id;
					$lineageArray[ $i ][ 'tree_id' ] = $tmp->tree_id;
					$lineageArray[ $i ][ 'menu_id' ] = $tmp->menu_id;
					
					$firstName = explode("(", $tmp->firstName );
					$lineageArray[ $i ][ 'firstName' ] = rtrim($firstName[0]);
					
					if ($this->lineageSetting == 1) {
						// Only first names
						$lineageArray[ $i ][ 'familyName' ] = null;
					} else if ($this->lineageSetting == 2) {
						// First names + family names
						$lineageArray[ $i ][ 'familyName' ] = $tmp->familyName;
					} else if ($this->lineageSetting == 3) {
						// First names + family names when different than previous
						if ($tmp->familyName == $reference_fam_name) {
							$lineageArray[ $i ][ 'familyName' ] = null;
						} else {
							$reference_fam_name = $tmp->familyName;
							$lineageArray[ $i ][ 'familyName' ] = $tmp->familyName;
						}
					}
					
					$tmp->__destruct();
					$i++;
				}
			}
		}
		
		return $lineageArray;
	}
}
?>
