<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		front end joaktreestart model - joaktreestart.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class JoaktreeModelJoaktreestart extends JModel {

	var $_tree_id		= null;
	var $_list_menu_id	= null;
	var $_person_menu_id	= null;
	var $_namelist;
	var $_treeinfo;

	function __construct() {
		parent::__construct();

                $this->_tree_id = JRequest::getVar('treeId'); 

		$query = 'SELECT id '
			.'FROM #__menu '
			.'WHERE link like ' . $this->_db->Quote( '%view=joaktreestart%' ) . ' '
			.'AND link like ' . $this->_db->Quote( '%treeId='.$this->_tree_id.'%' ) . ' ';

		$this->_db->setQuery( $query );
		$this->_list_menu_id = $this->_db->loadResult();

		$query = 'SELECT id '
			.'FROM #__menu '
			.'WHERE link like ' . $this->_db->Quote( '%&view=joaktree&%' ) . ' '
			.'AND link like ' . $this->_db->Quote( '%treeId='.$this->_tree_id.'%' ) . ' ';

		$this->_db->setQuery( $query );
		$this->_person_menu_id = $this->_db->loadResult();

	}

	function _buildTreeQuery()
	{
		$query = 'SELECT  * '
                        .'FROM    #__joaktree_trees '
			.'WHERE   id = ' . $this->_tree_id;

		return $query;
	}

	function _buildQuery()
	{
		// Get the WHERE clauses for the query
		$where      =  $this->_buildContentWhere();

		$query = 'SELECT  count(jpn.familyName) AS nameCount '
			.',       IF( jpn.namePreposition = '.$this->_db->Quote('').' '
			.'          , jpn.familyName '
			.'          , CONCAT_WS('.$this->_db->Quote(', ').',jpn.familyName,jpn.namePreposition) '
			.'          ) AS familyName '
                        .'FROM    (    #__joaktree_tree_persons jtp '
			.'        JOIN #__joaktree_persons      jpn '
			.'        ON      ( jpn.id = jtp.person_id ) '
			.'        ) '
			.'JOIN    #__joaktree_admin_persons     jan '
			.'ON      ( jan.id = jpn.id ) '
                        . $where . ' '
			.'GROUP BY CONCAT_WS('.$this->_db->Quote(', ').',jpn.familyName,jpn.namePreposition) ';
			
		return $query;
	}

	function _buildContentWhere()
	{
		$where = array();

		$where[] = 'jan.published = 1 '; 
                $where[] = 'jan.page = true '; 

                if ($this->_tree_id) {
                       $where[] = 'jtp.tree_id = ' . $this->_tree_id;
                }

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function getNamelist() {
		// Lets load the content if it doesn't already exist
		if (empty($this->_namelist)) {
			$query = $this->_buildQuery();
			$this->_namelist = $this->_getList( $query );
		}
		
		return $this->_namelist;
	}

	function getTreeinfo() {
		// Lets load the content if it doesn't already exist
		if (empty($this->_treeinfo)) {
			$query = $this->_buildTreeQuery();
			$this->_treeinfo = $this->_getList( $query );
		}
		
		return $this->_treeinfo;
	}

	function getTree_id() {        
		return $this->_tree_id;
	}

	function getList_menu_id() {        
		return $this->_list_menu_id;
	}

	function getPerson_menu_id() {        
		return $this->_person_menu_id;
	}
}
?>