<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		view joaktree person - view.html.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the JOaktree component
 */
class JoaktreeViewJoaktree extends JView {
	function display($tpl = null) {
		global $mainframe;
		$document		= &JFactory::getDocument();
		$this->params		= &$mainframe->getParams();
		$treeId 		= JRequest::getVar('treeId', 0, '', 'int');

		JHTML::stylesheet( 'joaktree.css', 'components/com_joaktree/assets/css/' );
		$document->addScript(JURI::base(true).'/components/com_joaktree/assets/js/toggle.js');

		JHTML::stylesheet( 'mod_briaskISS.css', 'components/com_joaktree/assets/css/' );
		$document->addScript(JURI::base(true).'/components/com_joaktree/assets/js/mod_briaskISS.js');
		
		// Person 
		$this->person		= $this->get( 'person' );  
		$this->partners		= $this->person->getPartners(); 
		
		// person + relations
		$Html[ 'person' ]	= $this->showPerson();
		$Html[ 'parents' ]	= $this->showParents();
		$Html[ 'partners' ]	= $this->showPartners();
		$Html[ 'children' ]	= $this->showChildren();
		$Html[ 'lineage' ]	= $this->showLineage();
		
		// Source
		$Html[ 'sourceButton' ]	= $this->showSources('button');
		$Html[ 'sourceText' ]	= $this->showSources('text');
		
		// Pictures
		$Html[ 'pictures' ]	= $this->showPictures();
		
		$this->assignRef( 'person',  $this->person );
		$this->assignRef( 'Html', $Html );

		parent::display($tpl);
	}
	

	private function showPerson() {
		$html = '';
		
		$html .= '<div class="jt-high-row">';
		if ( ($this->person->birthDate != null) or ($this->person->birthPlace != null) ) {
			$html .= '<span class="jt-label">' . JText::_('born') . ': </span>';
			$html .= $this->person->birthDate;
			if ($this->person->birthPlace != null) { 
				$html .= '&nbsp;' . JText::_('in') . '&nbsp;' . $this->person->birthPlace;
			}
		} else {
			$html .= '&nbsp;';
		} 
		$html .= '</div>';

		$html .= '<div class="jt-high-row">';
		if ( ($this->person->deathDate != null) or ($this->person->deathPlace != null) ) {
			$html .= '<span class="jt-label">' . JText::_('died') . ': </span>';
			$html .= $this->person->deathDate;
			if ($this->person->deathPlace != null) {
				$html .= '&nbsp;' . JText::_('in') . '&nbsp;' . $this->person->deathPlace;
			}
		} else {
			$html .= '&nbsp;';
		}
		$html .= '</div>';

		$html .= '<div class="jt-high-row">';
		if ( ($this->person->burialDate != null) or ($this->person->burialPlace != null) ) {
			$html .= '<span class="jt-label">' . JText::_('buried') . ': </span>';
			$html .= $this->person->burialDate;
			if ($this->person->burialPlace != null) {
				$html .= '&nbsp;' . JText::_('in') . '&nbsp;' . $this->person->burialPlace;
			}
		} else {
			$html .= '&nbsp;';
		}
		$html .= '</div>';
		
		// when title under picture is shown we need more space here
		$showPictureTitle		= $this->params->get('Sequence', 0);
		if ($showPictureTitle == 4) {
			$html .= '<div class="jt-high-title">&nbsp;</div>';
		}


		return $html;
	}
	
 	private function showParents() {
		$html = '';
		$fathers = $this->person->getFathers(); 
		$mothers = $this->person->getMothers(); 
		
		if ( (count( $fathers ) +  count( $mothers )) > 0) {
			$html .= '<tr>';
			$html .= '<th colspan="2"><h3>' . JText::_('parents') . '</h3></th>';
			$html .= $this->showHeadings();
			$html .= '</tr>';

			for ($i=0, $n=count( $fathers ); $i < $n; $i++) { 
				$link       = JRoute::_( 'index.php?option=com_joaktree&view=joaktree&treeId='.$fathers[$i]->tree_id.'&personId='. $fathers[$i]->id.'&Itemid='. $fathers[$i]->menu_id );
				
				$html .= '<tr>';
				$html .= '<td>&nbsp;</td>';
				
				$html .= '<td>';
				if ($fathers[$i]->page) { 
					$html .= '<a href="' . $link . '">';
				}
				$html .= $fathers[$i]->firstNamePatronym . " " . $fathers[$i]->familyName;
				if ($fathers[$i]->page) { 
					$html .= '</a>';
				}
				$html .= '</td>';
				
				$html .= '<td align="center">' . $fathers[$i]->birthDate . '</td>';
				$html .= '<td align="center">' . $fathers[$i]->deathDate . '</td>';
				$html .= '<td align="center">' . $fathers[$i]->burialDate . '</td>';
				$html .= '</tr>';
			} 

			for ($i=0, $n=count( $mothers ); $i < $n; $i++) {
				$link       = JRoute::_( 'index.php?option=com_joaktree&view=joaktree&treeId='.$mothers[$i]->tree_id.'&personId='. $mothers[$i]->id.'&Itemid='. $mothers[$i]->menu_id );

				$html .= '<tr>';
				$html .= '<td>&nbsp;</td>';
				
				$html .= '<td>';
				if ($mothers[$i]->page) { 
					$html .= '<a href="' . $link . '">';
				}
				$html .= $mothers[$i]->firstNamePatronym . " " . $mothers[$i]->familyName;
				if ($mothers[$i]->page) { 
					$html .= '</a>';
				}
				$html .= '</td>';
				
				$html .= '<td align="center">' . $mothers[$i]->birthDate . '</td>';
				$html .= '<td align="center">' . $mothers[$i]->deathDate . '</td>';
				$html .= '<td align="center">' . $mothers[$i]->burialDate . '</td>';
				$html .= '</tr>';
			} 
		}
		return $html;
	}

 	private function showPartners() {
		$html = '';
		
		if (count( $this->partners ) > 0) {
			$html .= '<tr>';
			$html .= '<th colspan="2"><h3>';
			
			if (count( $this->partners ) == 1) {
				switch ( $this->partners[0]->sex ) {
					case "M":	$html .= JText::_('husband');
							BREAK;
					case "F": 	$html .= JText::_('wife');
							BREAK;
					default: 	$html .= JText::_('partner');
							BREAK;
				}
			} else {
				switch ( $this->partners[0]->sex ) {
					case "M":	$html .= JText::_('husbands');
							BREAK;
					case "F": 	$html .= JText::_('wifes');
							BREAK;
					default: 	$html .= JText::_('partners');
							BREAK;
				}
			}
			
			$html .= '</h3></th>';
			$html .= $this->showHeadings();
			$html .= '</tr>';

			for ($i=0, $n=count( $this->partners ); $i < $n; $i++) {
				$link       = JRoute::_( 'index.php?option=com_joaktree&view=joaktree&treeId='.$this->partners[$i]->tree_id.'&personId='. $this->partners[$i]->id.'&Itemid='. $this->partners[$i]->menu_id );
				
	
				$html .= '<tr>';
				$html .= '<td><p>&nbsp;</p></td>';
				$html .= '<td>';
				if ($this->partners[$i]->page) {
					$html .= '<a href="' .  $link . '">'; 
				}
				$html .= $this->partners[$i]->firstNamePatronym . " " . $this->partners[$i]->familyName;
				if ($this->partners[$i]->page) {
					$html .= '</a>'; 
				}
				
				// show marriage information
				$marriage = null;
				if ($this->partners[$i]->marriageDate != null) {
					$marriage = $this->partners[$i]->marriageDate;
				}
				if ($this->partners[$i]->marriagePlace != null) {
					$marriage .= ' ' . JText::_('in') . ' ' . $this->partners[$i]->marriagePlace;
				}
				if ($marriage != null) {
					$html .= '<div>';
					$html .= '<span class="jt-label">' . JText::_('married') . ': </span>' . $marriage;
					$html .= '</div>';
				}
				$html .= '</td>';
				
				$html .= '<td align="center">' . $this->partners[$i]->birthDate . '</td>';
				$html .= '<td align="center">' . $this->partners[$i]->deathDate . '</td>';
				$html .= '<td align="center">' . $this->partners[$i]->burialDate . '</td>';
				$html .= '</tr>';
			}
		}
		return $html;
	}

	private function showChildren() {
		$html		= '';
		$children	= $this->person->getChildren();
		
		// when there are no children , skip this routine
		if (count($children) > 0 ) {
			// check for children with only one parent
			$counter_1 = 0;
			for ($i=0, $n=count( $children ); $i < $n; $i++) {
				if ( $children[$i]->secondParent_id == null ) {
					$counter_1++;
				}
			}
			
			if ($counter_1 > 0) {
				// children with only one parent
				$html .= '<tr>';
				$html .= '<th colspan="2"><h3>' . JText::_('children') . '</h3></th>';
				$html .= $this->showHeadings();
				$html .= '</tr>';
				
				// loop through the children and filter on the one parent children
				for ($i=0, $n=count( $children ); $i < $n; $i++) {
					if ( $children[$i]->secondParent_id == null ) {
						$html .= $this->displayChild( $children[$i] );
					}
				}
			}
			
			// check for situation of only one spouse, and no childresn out of wedlock
			if ( ( $counter_1 == 0 ) and ( count($this->partners) == 1 ) ) {
				// display children from one partner
				$html .= '<tr>';
				$html .= '<th colspan="2"><h3>' . JText::_('children') . '</h3></th>';
				$html .= $this->showHeadings();
				$html .= '</tr>';
				
				// loop through the children without filtering
				for ($i=0, $n=count( $children ); $i < $n; $i++) {
					$html .= $this->displayChild( $children[$i] );
				}
			} else {
				// loop through the partners of person
				for ($j=0, $m=count( $this->partners ); $j < $m; $j++) {
					// count children for this partner
					$counter = 0;
					for ($i=0, $n=count( $children ); $i < $n; $i++) {
						if ( $children[$i]->secondParent_id == $this->partners[$j]->id ) {
							$counter++;
						}
					}
					
					if ($counter > 0) {
						// children with this partner
						// remove first brackets
						$partnerName = explode('(', $this->partners[$j]->firstName);
						
						$html .= '<tr>';
						$html .= '<th colspan="2"><h3>' . JText::_('children with') . ' ' . $partnerName[0] . '</h3></th>';
						$html .= $this->showHeadings();
						$html .= '</tr>';
						
						// loop through the children and filter on the one parent children
						for ($i=0, $n=count( $children ); $i < $n; $i++) {
							if ( $children[$i]->secondParent_id == $this->partners[$j]->id ) {
								$html .= $this->displayChild( $children[$i] );
							}
						}
					}
					
				}
			}
		}

		return $html;
	}
	
	private function displayChild( $child ) {
		$link  = JRoute::_( 'index.php?option=com_joaktree&view=joaktree&treeId='.$child->tree_id.'&personId='. $child->id.'&Itemid='. $child->menu_id );
		$html  = '';
		
		$html .= '<tr>';
		$html .= '<td>&nbsp;</td>';
		$html .= '<td>';
		
		if ($child->page) { 
			$html .= '<a href="' . $link . '">'; 
		}
		$html .= $child->firstNamePatronym . " " . $child->familyName;
		if ($child->page) { 
			$html .= '</a>'; 
		}
		$html .= '</td>';
		
		// dates
		$html .= '<td align="center">' . $child->birthDate . '</td>';
		$html .= '<td align="center">' . $child->deathDate . '</td>';
		$html .= '<td align="center">' . $child->burialDate . '</td>';
		
		$html .= '</tr>';
		
		return $html;
	}
	
	private function showHeadings() {
		$html = '';
		
		$html .= '<th><h3 align="center">' . JText::_('born') . '</h3></th>';
		$html .= '<th><h3 align="center">' . JText::_('died') . '</h3></th>';
		$html .= '<th><h3 align="center">' . JText::_('buried') . '</h3></th>';
		
		return $html;
	}
	
	private function showLineage() {
		$html = '';

		$lineageArray		= $this->person->getLineage(); 

		if ($lineageArray[0] != null) {
			$html .= '<div class="jt-small"><span>';
			
			for ($i=0, $n=count( $lineageArray ); $i < $n; $i++) {
				$link = JRoute::_( 'index.php?option=com_joaktree&view=joaktree&treeId='.$lineageArray[$i][ 'tree_id' ].'&personId='. $lineageArray[$i][ 'person_id' ].'&Itemid='. $lineageArray[$i][ 'menu_id' ] );
				$name = $lineageArray[$i][ 'firstName' ];
				if ($lineageArray[$i][ 'familyName' ] != null) {
					$name .= ' ' . $lineageArray[$i][ 'familyName' ];
				}
				
				if (($i == 0 ) and ($i != ($n-1) )) {
					// first name and not the last name
					$html .= '<a href="'.$link.'">'; 
					$html .= $name;
					$html .= '</a>'; 
				} else if (($i == 0 ) and ($i == ($n-1) )) {
					// first name and the last name
					$html .= $name;
				} else if (($i != 0 ) and ($i != ($n-1) )) {
					// not the first name and not the last name
					$html .= '<a class="jt-icon-lineage" href="'.$link.'">'; 
					$html .= '&nbsp;&nbsp;' . $name; 
					$html .= '</a>'; 
				} else if (($i != 0 ) and ($i == ($n-1) )) {
					// not the first name but the last name
					$html .= '<span class="jt-icon-lineage">'; 
					$html .= '&nbsp;&nbsp;' . $name; 
					$html .= '</span>'; 
				}
			}
			$html .= '</span></div>';
		}
		return $html;
	}

	private function showSourceLines($sources) {
		$htnl = '';
		// loop through sources
		for ($i=0, $n=count( $sources ); $i < $n; $i++) { 
			$html .= '<p><i>' . $sources[$i]->title . '</i>';
			if ($sources[$i]->publication) {
				$html .= ', ' . $sources[$i]->publication;
			}
			if ($sources[$i]->author) {
				$html .= '(' . $sources[$i]->author . ')';
			}
			$html .= ', ' . $sources[$i]->sourceText;
			if ($sources[$i]->repository) {
				$html .= '[';
				if ($sources[$i]->website) {
					$html .= '<a href="' . $sources[$i]->website . '" target="_repository">';
				}
				$html .= $sources[$i]->repository;
				if ($sources[$i]->website) {
					$html .= '</a>';
				}
				$html .= ']';
			}
			$html .= '</p>';
		} // end of loop
		return $html;
	}
	
	private function showSources($element){
		$html = '';
		$sources = $this->person->getSources(); 
		
		if ( count( $sources ) > 0 ) {
			if ($element == 'button') {
				$html .= '<p><a href="#" class="jt-sources-closed" onclick="toggle(this, \'jtsourceid\');return false;">' . JText::_('sources') . '</a></p>';
			} else if ($element == 'text') {
				// no java script - sources are always shown
				$html .= '<noscript><div id="jtsourceid" class="jt-show"><div class="jt-source">';
				$html .= $this->showSourceLines($sources);
				$html .= '</div></div></noscript>';
				
				// java script enabled - sources are initially hidden
				$html .= '<div id="jtsourceid" class="jt-hide">';
				$html .= '<div class="jt-source">';
				$html .= $this->showSourceLines($sources);
				$html .= '</div></div>';
			}
		}
		
		return $html;
	}
	
	private function showPictures() {
		$html = '';
		$pictures = array();
		$picArray = $this->get( 'pictures' );
		
		if (count($picArray) != 0) {
			// there are pictures in the array
			$pictures[ 'Sequence']		= $this->params->get('Sequence', 0);
			$pictures[ 'pxHeight']		= $this->params->get('pxHeight', 0);
			$pictures[ 'pxWidth']		= $this->params->get('pxWidth', 0);
			$pictures[ 'Title']		= $this->params->get('Title', 0);

			if ( ($pictures[ 'Sequence'] == 1) or ($pictures[ 'Sequence'] == 2) ) {
				// sequence <> 3: slideshow is asked for
				$pictures[ 'nextDelay' ]	= $this->params->get('nextDelay', 0);
				$pictures[ 'transDelay' ]	= $this->params->get('transDelay', 0);
		
				if (count($picArray) > 1) {
					// There are more than 1 pictures in array -> slide show can be created
					$html .= '<noscript><div>ImageSlideShow requires Javascript</div></noscript>';
					
					// when height or width is empty or zero, picture will have its own size
					if (( $pictures[ 'pxWidth' ] == 0) or ($pictures[ 'pxHeight' ] == 0) ) {
						$html .= '<ul id="briask-iss99" class="briask-iss">';
					} else {
						$html .= '<ul id="briask-iss99" class="briask-iss" style="width:'. $pictures[ 'pxWidth' ].'px;height:'.$pictures[ 'pxHeight' ].'px">';
					}
					
					foreach ($picArray as $file) {
						$html .= '<li><img src="'.$file.'" alt="'.$pictures[ 'Title' ].'" /></li>';
					}
					$html .= '</ul>';
					
					$html .= '<script type="text/javascript">';
					$html .= 'var briaskPics99 = [0]; ';
					$html .= 'var briaskInstance99 = new briaskISS(99,'.$pictures[ 'Sequence' ].','.$pictures[ 'nextDelay' ].','.$pictures[ 'transDelay' ].', briaskPics99);';
					$html .= '</script>';
				} else if (count($picArray) == 1) {
					// just one picture in array -> no need for slide show
					// when height or width is empty or zero, picture will have its own size
					if (( $pictures[ 'pxWidth' ] == 0) or ($pictures[ 'pxHeight' ] == 0) ) {
						$html .= '<img src="'.$picArray[0].'" alt="'. $pictures[ 'Title' ].'" />';
					} else {
						$html .= '<img src="'.$picArray[0].'" alt="'. $pictures[ 'Title' ].'" height="'.$pictures[ 'pxHeight' ].'" width="'. $pictures[ 'pxWidth' ].'" />';
					}
				}
			} else {
				// sequence = 3 or 4: no slideshow - just show first picture
				// when height or width is empty or zero, picture will have its own size
				if (( $pictures[ 'pxWidth' ] == 0) or ($pictures[ 'pxHeight' ] == 0) ) {
					$html .= '<img src="'.$picArray[0].'" alt="'. $pictures[ 'Title' ].'" />';
				} else {
					$html .= '<img src="'.$picArray[0].'" alt="'. $pictures[ 'Title' ].'" height="'.$pictures[ 'pxHeight' ].'" width="'. $pictures[ 'pxWidth' ].'" />';
				}
				
				if ($pictures[ 'Sequence'] == 4) {
					// create the name to be shown
					$tmpPictureName_1 = explode(DS, $picArray[0]);
					$tmpPictureName_2 = explode('.', $tmpPictureName_1[ count($tmpPictureName_1) - 1 ]);
					$pictureName	  = $tmpPictureName_2[0];
					
					$html .= '<div class="jt-high-title jt-picture-title">' . $pictureName . '</div>';
				} 
			}
		}
		return $html;
	}
	
}
?>