<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		view joaktree list - view.html.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the JOaktree component
 */
class JoaktreeViewJoaktreeList extends JView {
	function display($tpl = null) {
		
		global $mainframe;
		$params			= &$mainframe->getParams();
		
		JHTML::stylesheet( 'joaktree.css', 'components/com_joaktree/assets/css/' );
		
		// Get data from the model
		$personlist		= $this->get( 'personlist' );  
		$pagination		= & $this->get( 'Pagination' );
		$list_menu_id		= $this->get( 'list_menu_id' );  
		$person_menu_id		= $this->get( 'person_menu_id' );  
		$tree_id		= $this->get( 'tree_id' );  
		$patronymSetting	= $this->get( 'patronymSetting' );  
		
		// Id's and settings
		$lists['tree_id']	= $tree_id;
		$lists['list_menu_id']	= $list_menu_id;
		$lists['person_menu_id'] = $person_menu_id;
		$lists['patronym'] 	= $patronymSetting;
		
		//Filter
		$context		= 'com_joaktree.joaktreelist.list.';
			
		$filter_order		= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'jpn.familyName',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',			'word' );
		$search1		= $mainframe->getUserStateFromRequest( $context.'search1',	'search1',	'',	'string' );
		$search1		= JString::strtolower( $search1 );
		$search2		= $mainframe->getUserStateFromRequest( $context.'search2',	'search2',	'',	'string' );
		$search2		= JString::strtolower( $search2 );
		$search3		= $mainframe->getUserStateFromRequest( $context.'search3',	'search3',	'',	'string' );
		$search3		= JString::strtolower( $search3 );
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order'] 	= $filter_order;
		
		// search filter
		$lists['searchWidth']	= $params->get('search_width', '10');;
		$lists['search1']	= $search1;
		$lists['search2']	= $search2;
		$lists['search3']	= $search3;
		
		// colors
		$lists['color_heading']	= '#' . $params->get('heading_back', 'FFFFFF');
		$lists['color_text']	= '#' . $params->get('heading_text', '000000');
		
		$this->assignRef('pagination',	$pagination);
		$this->assignRef( 'personlist', $personlist );
		$this->assignRef('lists',	$lists);
		
		parent::display($tpl);
	}
}
?>