<?php
/**
 * Joomla! 1.5 component JOaktree
 * file		view joaktree start - view.html.php
 *
 * @version	1.0
 * @author	Niels van Dantzig
 * @package	Joomla
 * @subpackage	JOaktree
 * @license	GNU/GPL
 *
 * Viewer for genealogical data for Joomla!
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the JOaktree component
 */
class JoaktreeViewJoaktreeStart extends JView {
	function display($tpl = null) {
		
		global $mainframe;
		$this->params	= &$mainframe->getParams();
		$this->columns 	= (int) $this->params->get('columns', '3');

		JHTML::stylesheet( 'joaktree.css', 'components/com_joaktree/assets/css/' );
		
		// Get data from the model
		$treeinfo		= $this->get( 'treeinfo' );  
		$list_menu_id		= $this->get( 'list_menu_id' );  
		$person_menu_id		= $this->get( 'person_menu_id' );  
		$tree_id		= $this->get( 'tree_id' );  
		
		// Id's and settings
		$this->lists['tree_id']	= $tree_id;
		$this->lists['list_menu_id']	= $list_menu_id;
		$this->lists['person_menu_id'] = $person_menu_id;
		
		//namelist
		$html['index'] = $this->showIndex(); 
		$html['indexHeader'] = $this->showIndexHeadFoot(); 
		
		// colors
		$this->lists['color_heading']	= '#' . $this->params->get('heading_back', 'FFFFFF');
		$this->lists['color_text']	= '#' . $this->params->get('heading_text', '000000');
		
		$this->assignRef('treeinfo', $treeinfo );
		$this->assignRef('html', $html );
		$this->assignRef('lists',	$this->lists);
		
		parent::display($tpl);
	}
	
	private function showIndexHeadFoot() {
		$html = '';
		
		if ($this->columns <> 0) {
			// header
			$html .= '<thead><tr><th colspan="'.($this->columns+1).'" class="jt-content-th">';
			$html .= '<h3><span style="float: left; width: 10%; margin-bottom: 14px;"><a name="top">&nbsp;&nbsp;&nbsp;'.JText::_( 'Index' ) . '</a>&nbsp;&nbsp;&nbsp;</span>';
			
			$html .= '<span style="float: right; margin-bottom: 14px;">';
			//$html .= '<h3 style="float:right;">';
			for ($i=0, $n=count($this->indexLetterArray); $i < $n; $i++) {
				$html .= '<a href="#'.$this->indexLetterArray[$i].'">'.$this->indexLetterArray[$i].'</a>&nbsp;&nbsp;&nbsp;';
			}
			$html .= '</span></h3>';
			$html .= '</th></tr></thead>';

			// footer
			$html .= '<tfoot><tr><td colspan="'.($this->columns+1).'">&nbsp;</td></tr></tfoot>';
		}
		
		return $html;
	}


	private function showIndex() {
		$html = '';
		$groupCountSetting = (int) $this->params->get('groupCount', '3');
		$this->indexLetterArray = array();
		
		if ($this->columns <> 0) {
			$_namelist  = $this->get( 'namelist' );
			$namelist   = array();
 			
			// body
			$html .= '<tbody>';
			
			// first records
			$indexletter = strtoupper( substr($_namelist[0]->familyName, 0 , 1) );
			$groupCount = 1;
			$namelist[] = $_namelist[0];
			
			// now the loop starts at value 1
			for ($i=1, $n=count( $_namelist ); $i < $n; $i++) {
				// compare this element with the previous
				if (     strtoupper( substr($_namelist[$i]->familyName, 0 , 1) ) 
				     ==  strtoupper( substr($_namelist[$i-1]->familyName, 0 , 1) ) 
				     ) {
					 // same first letter - just add the element to the array
					 $namelist[] = $_namelist[$i];
				} else {
					// different first letter - end previous index letter and start a new one.
					if ( ($groupCount == $groupCountSetting) or ($groupCountSetting == 0) ) {
						$html .= $this->showIndexLetter($indexletter, $namelist);
						array_splice($namelist, 0);
						$indexletter = strtoupper( substr($_namelist[$i]->familyName, 0 , 1) );
						$groupCount = 1;
					} else {
						$groupCount++;
						if ($groupCount == $groupCountSetting) {
							$indexletter .= ' - ' . strtoupper( substr($_namelist[$i]->familyName, 0 , 1) );
						}
					}
					
 					$namelist[] = $_namelist[$i];
				}
			}
			
			// show the last index letter
			$html .= $this->showIndexLetter($indexletter, $namelist);
		}
		
		$html .= '</tbody>';
		
		return $html;
	}
	
	private function showIndexLetter($indexletter, $namelist) {
		$html = '';
		$this->indexLetterArray[] = $indexletter;
		
		$numberRows = (int) ceil( count($namelist) /  $this->columns);
		
		$html .= '<tr><th colspan="'.($this->columns+1).'"><a name="'.$indexletter.'"></a><h3>';
		$html .= '<span style="float: left; width: 40%; margin-bottom: 14px;">'.$indexletter.'</span>';
		$html .= '<span style="float: right; margin-bottom: 14px;"><a href="#top">'.JText::_( 'go to top' ).'</a></span>';
		$html .= '</h3></th></tr>';

		$k = 2;
		for ($i=0, $n=$numberRows; $i < $n; $i++) {
			$rowclass = 'jt-index-entry' . $k;
			
			$html .= '<tr class="' . $rowclass . '">';
			$html .= '<td class="jt-small">&nbsp;</td>';
			
			for ($j=0, $m=$this->columns; $j < $m; $j++) {
				$cell = $namelist[$i+($j*$numberRows)];
				
				if ($cell->familyName != null) {
					$linkName = explode(',', $cell->familyName);
					$link = JRoute::_( 'index.php?option=com_joaktree&search3='.$linkName[0]
							.'&view=joaktreelist&treeId='.$this->lists['tree_id']
							.'&Itemid='.$this->lists['person_menu_id'] 
							);
					$html .= '<td class="jt-small"><a href="'.$link.'">' . $cell->familyName . ' (' . $cell->nameCount . ')' . '</a></td>';
				} else {
					$html .= '<td class="jt-small">&nbsp;</td>';
				}
			}
			
			$html .= '</tr>';
			$k = 3 - $k;
		}
		
		return $html;
	}
}
?>